#include <iostream>
#include <cmath>
using namespace std;

class Vektor 
{
   double x;
   double y;

public:
   Vektor(double _x, double _y) : x(_x), y(_y)
   {
   }

   double laenge() const
   { 
       return sqrt(x*x + y*y); 
   }    

   Vektor& operator+=(const Vektor & v);
   Vektor  operator+ (const Vektor & v);
   friend ostream& operator<<(ostream& os, const Vektor& v);
   friend bool operator== (const Vektor v1, const Vektor v2);  
   friend bool operator!= (const Vektor v1, const Vektor v2);  
};

// berladung im Dateibereich
Vektor& Vektor::operator+=(const Vektor& v)  
{
   x += v.x;  
   y += v.y;  
   return *this;
}
Vektor Vektor::operator+(const Vektor& v)  
{
   Vektor tmp(x, y);
   return tmp += v;
}

// Friend-Funktionen
bool operator== (const Vektor v1, const Vektor v2) 
{
    return (v1.x == v2.x) && (v1.y == v2.y);
}    
bool operator!= (const Vektor v1, const Vektor v2) 
{
    return !(v1 == v2);
}    
ostream& operator<<(ostream& os, const Vektor& v)
{
   os << "(" << v.x << "," << v.y << ")";
   return os;
}

// Globale Operatorfunktionen
bool operator< (const Vektor v1, const Vektor v2) 
{
    return v1.laenge() < v2.laenge();
}    
bool operator<= (const Vektor v1, const Vektor v2) 
{
    return !(v2 < v1);
}    
bool operator> (const Vektor v1, const Vektor v2) 
{
    return v2 < v1;
}    
bool operator>= (const Vektor v1, const Vektor v2) 
{
    return !(v1 < v2);
}    


int main()
{
   Vektor v1(0,0);
   Vektor v2(10,5);
   Vektor v3(-1,1);
   Vektor v4(8,7);

   cout << endl << " Ausgabe der erzeugten Vektoren: " << endl;
   cout << " v1: " << v1 << endl;
   cout << " v2: " << v2 << endl;
   cout << " v3: " << v3 << endl;
   cout << " v4: " << v4 << endl;

   cout << endl << " Rechne v1 = v2 + v3; " << endl;
   v1 = v2 + v3;
   cout << " v1: " << v1 << endl;
   cout << " v2: " << v2 << endl;
   cout << " v3: " << v3 << endl;
   cout << " v4: " << v4 << endl;

   cout << endl << " Rechne v1 += v3; " << endl;
   v1 += v3;
   cout << " v1: " << v1 << endl;
   cout << " v2: " << v2 << endl;
   cout << " v3: " << v3 << endl;
   cout << " v4: " << v4 << endl;

   cout << endl << " Test auf Gleichheit " << endl;
   if (v1 == v3)
      cout << " v1 ist gleich v3 " << endl;
   else
      cout << " v1 ist ungleich v3 " << endl;
   if (v1 == v4)
      cout << " v1 ist gleich v4 " << endl;
   else
      cout << " v1 ist ungleich v4 " << endl;


   cout << endl << " Groessenvergleich " << endl;
   if (v1 < v4)
      cout << " v1 ist kleiner v4 " << endl;
   else
      cout << " v1 ist groesser oder gleich v4 " << endl;
   if (v1 > v4)
      cout << " v1 ist groesser v4 " << endl;
   else
      cout << " v1 ist kleiner oder gleich v4 " << endl;

   cout << endl;

   return 0;
}