/* Testprogramm zur Klasse Vektor
 *
 * Die main()-Funktion erzeugt zwei Vektor-Objekt
 * Dann addiert und subtrahiert sie diese, einmal mit den
 * statischen und einmal mit den nicht-statischen Memberfunktionen
 *
 * Nach jeder Operation wird das Ergebnis zur Kontrolle ausgegeben.
 * Auerdem prft die main()-Funktion, ob die jeweilige Operation korrekt
 * durchgefhrt wurde und gibt eine entsprechende Meldung aus.
 *
 * Scheitert ein Test, wird das Programm beendet.
*/

#include <iostream>
#include "Vektor.hpp"
using namespace std;

int main()
{
  Vektor v1(1,2);
  Vektor v2(10,20);
  Vektor v;
  bool testergebnisse[4] = {false, false, false, false};

  cout << endl;
  cout << " Testprogramm zur Klasse Vektor " << endl << endl;

  // Vektor ausgeben
  cout << " Vektor 1: " << v1.alsString() << endl;
  cout << " Vektor 2: " << v2.alsString() << endl;



  // 1. Test 

  cout <<  endl << " 1. Test: v1.addieren(v2) " << endl;
  v1.addieren(v2);
  cout << " Vektor 1 nach Addition von Vektor 2: " << v1.alsString() << endl;

  // Testergebnisse kontrollieren
  if (v1.get_x() == 11 && v1.get_y() == 22)
  {
     cout << " Test erfolgreich " << endl;
     testergebnisse[0] = true;
  }
  else
  {
     cout << " Test gescheitert " << endl;
     return 0;
  }



  // 2. Test 

  cout <<  endl << " 2. Test: v1.subtrahieren(v2) " << endl;
  v1.subtrahieren(v2);
  cout << " Vektor 1 nach Subtraktion von Vektor 2: " << v1.alsString() << endl;

  // Testergebnisse kontrollieren
  if (v1.get_x() == 1 && v1.get_y() == 2)
  {
     cout << " Test erfolgreich " << endl;
     testergebnisse[1] = true;
  }
  else
  {
     cout << " Test gescheitert " << endl;
     return 0;
  }



  // 3. Test 
  
  cout <<  endl << " 3. Test: Vektor::addieren(v1, v2) " << endl;
  v = Vektor::addieren(v1, v2);
  cout << " Ergebnis der Addition von Vektor 1 und 2: " << v.alsString() << endl;

  // Testergebnisse kontrollieren
  if (v.get_x() == 11 && v.get_y() == 22)
  {
     cout << " Test erfolgreich " << endl;
     testergebnisse[2] = true;
  }
  else
  {
     cout << " Test gescheitert " << endl;
     return 0;
  }



  // 4. Test 

  cout <<  endl << " 4. Test: v = Vektor::subtrahieren(v1, v2) " << endl;
  v = Vektor::subtrahieren(v1, v2);
  cout << " Ergebnis der Subtraktion von Vektor 1 und 2: " << v.alsString() << endl;

  // Testergebnisse kontrollieren
  if (v.get_x() == -9 && v.get_y() == -18)
  {
     cout << " Test erfolgreich " << endl;
     testergebnisse[3] = true;
  }
  else
  {
     cout << " Test gescheitert " << endl;
     return 0;
  }


  cout << endl << endl;

  return 0;
}
